from enigma import eTimer
from Screens.Screen import Screen
from Components.ActionMap import ActionMap
from Plugins.Plugin import PluginDescriptor

useInstantiateDialog = True

_daemonInstance = None

class Dialog(Screen):

	def __init__(self, session):

		self.skin = """<screen name="Dialog" position="0,0" size="400,400" backgroundColor="#00000000" transparent="0" flags="wfNoBorder" zPosition="11"><eLabel position="150,190" size= "100,20" text="Hello world!" backgroundColor="#00000000" font="Regular;16" /></screen>"""

		Screen.__init__(self, session)

		self["actions"] = ActionMap(["ColorActions"],
		{
			"blue": self.keyBlue,
			"green": self.keyGreen,
		}, -2)

	def keyBlue(self):
		print "Daemon Dialog.Success"

	def keyGreen(self):
		print "Daemon Dialog.close"
		if useInstantiateDialog:
			self.execEnd()
			self.hide()
		else:
			self.close()


class Daemon(object):

	def __init__(self, session):
		self.session = session
		if useInstantiateDialog:
			self.dialog = self.session.instantiateDialog(Dialog)
		self.startupTimer = eTimer()
		self.startupTimer.callback.append(self.createScreen)
		self.startupTimer.start(30 * 1000, 1)

	def createScreen(self):
		print "Daemon.createScreen()"
		if useInstantiateDialog:
			self.dialog.show()
			self.dialog.execBegin()
		else:
			self.session.open(Dialog)

def startDaemon(session=None, reason=None):
	global _daemonInstance
	if reason and _daemonInstance:
		_daemonInstance = None
	elif not (reason or _daemonInstance):
		_daemonInstance = Daemon(session)

def Plugins(**kwargs):
	DescriptorList = []   
	DescriptorList.append(
		PluginDescriptor(
			name="Daemon",
			where = PluginDescriptor.WHERE_SESSIONSTART,
			description=_("Daemon"),
			fnc=startDaemon
		)
	)
	return DescriptorList
